/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of AIO.xs. Do not edit this file, edit AIO.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "AIO.xs"
#include "libeio/xthread.h"

#include <errno.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <stddef.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <limits.h>
#include <fcntl.h>
#include <sched.h>

/* perl namespace pollution */
#undef VERSION

#ifdef _WIN32

# define EIO_STRUCT_DIRENT Direntry_t
# undef malloc
# undef free

// perl overrides all those nice win32 functions
# undef open
# undef read
# undef write
# undef send
# undef recv
# undef stat
# undef fstat
# define lstat stat
# undef truncate
# undef ftruncate
# undef open
# undef close
# undef unlink
# undef rmdir
# undef rename
# undef lseek

# define chown(a,b,c)    (errno = ENOSYS, -1)
# define fchown(a,b,c)   (errno = ENOSYS, -1)
# define fchmod(a,b)     (errno = ENOSYS, -1)
# define symlink(a,b)    (errno = ENOSYS, -1)
# define readlink(a,b,c) (errno = ENOSYS, -1)
# define mknod(a,b,c)    (errno = ENOSYS, -1)
# define truncate(a,b)   (errno = ENOSYS, -1)
# define ftruncate(fd,o) chsize ((fd), (o))
# define fsync(fd)       _commit (fd)
# define opendir(fd)     (errno = ENOSYS, 0)
# define readdir(fd)     (errno = ENOSYS, -1)
# define closedir(fd)    (errno = ENOSYS, -1)
# define mkdir(a,b)      mkdir (a)

#else

# include <sys/time.h>
# include <sys/select.h>
# include <unistd.h>
# include <utime.h>
# include <signal.h>
# define EIO_STRUCT_DIRENT struct dirent

#endif

/* perl stupidly overrides readdir and maybe others */
/* with thread-unsafe versions, imagine that :( */
#undef readdir
#undef opendir
#undef closedir

#define EIO_STRUCT_STAT Stat_t

/* use NV for 32 bit perls as it allows larger offsets */
#if IVSIZE >= 8
# define SvVAL64 SvIV
#else
# define SvVAL64 SvNV
#endif

/*****************************************************************************/

#if __GNUC__ >= 3
# define expect(expr,value) __builtin_expect ((expr),(value))
#else
# define expect(expr,value) (expr)
#endif

#define expect_false(expr) expect ((expr) != 0, 0)
#define expect_true(expr)  expect ((expr) != 0, 1)

/*****************************************************************************/

static HV *stash;
typedef SV SV8; /* byte-sv, used for argument-checking */

#define AIO_REQ_KLASS "IO::AIO::REQ"
#define AIO_GRP_KLASS "IO::AIO::GRP"

#define EIO_REQ_MEMBERS	\
  SV *callback;		\
  SV *sv1, *sv2;	\
  STRLEN stroffset;	\
  SV *self;

#define EIO_NO_WRAPPERS 1

#include "libeio/eio.h"

static int req_invoke    (eio_req *req);
#define EIO_FINISH(req)  req_invoke (req)
static void req_destroy  (eio_req *grp);
#define EIO_DESTROY(req) req_destroy (req)

enum {
  FLAG_SV2_RO_OFF = 0x40, /* data was set readonly */
};

#include "libeio/eio.c"

typedef eio_req *aio_req;
typedef eio_req *aio_req_ornot;

static SV *on_next_submit;
static int next_pri = EIO_PRI_DEFAULT;
static int max_outstanding;

static int respipe_osf [2], respipe [2] = { -1, -1 };

static void req_destroy (aio_req req);
static void req_cancel (aio_req req);

static void want_poll (void)
{
  /* write a dummy byte to the pipe so fh becomes ready */
  respipe_write (respipe_osf [1], (const void *)&respipe_osf, 1);
}

static void done_poll (void)
{
  /* read any signals sent by the worker threads */
  char buf [4];
  while (respipe_read (respipe [0], buf, 4) == 4)
    ;
}

/* must be called at most once */
static SV *req_sv (aio_req req, const char *klass)
{
  if (!req->self)
    {
      req->self = (SV *)newHV ();
      sv_magic (req->self, 0, PERL_MAGIC_ext, (char *)req, 0);
    }

  return sv_2mortal (sv_bless (newRV_inc (req->self), gv_stashpv (klass, 1)));
}

static aio_req SvAIO_REQ (SV *sv)
{
  MAGIC *mg;

  if (!sv_derived_from (sv, AIO_REQ_KLASS) || !SvROK (sv))
    croak ("object of class " AIO_REQ_KLASS " expected");

  mg = mg_find (SvRV (sv), PERL_MAGIC_ext);

  return mg ? (aio_req)mg->mg_ptr : 0;
}

static void aio_grp_feed (aio_req grp)
{
  if (grp->sv2 && SvOK (grp->sv2))
    {
      dSP;

      ENTER;
      SAVETMPS;
      PUSHMARK (SP);
      XPUSHs (req_sv (grp, AIO_GRP_KLASS));
      PUTBACK;
      call_sv (grp->sv2, G_VOID | G_EVAL | G_KEEPERR);
      SPAGAIN;
      FREETMPS;
      LEAVE;
    }
}

static void req_submit (eio_req *req)
{
  eio_submit (req);

  if (expect_false (on_next_submit))
    {
      dSP;
      SV *cb = sv_2mortal (on_next_submit);

      on_next_submit = 0;

      PUSHMARK (SP);
      PUTBACK;
      call_sv (cb, G_DISCARD | G_EVAL);
    }
}

static int req_invoke (eio_req *req)
{
  dSP;

  if (req->flags & FLAG_SV2_RO_OFF)
    SvREADONLY_off (req->sv2);

  if (!EIO_CANCELLED (req) && req->callback)
    {
      ENTER;
      SAVETMPS;
      PUSHMARK (SP);
      EXTEND (SP, 1);

      switch (req->type)
        {
          case EIO_READDIR:
            {
              SV *rv = &PL_sv_undef;

              if (req->result >= 0)
                {
                  int i;
                  char *buf = req->ptr2;
                  AV *av = newAV ();

                  av_extend (av, req->result - 1);

                  for (i = 0; i < req->result; ++i)
                    {
                      SV *sv = newSVpv (buf, 0);

                      av_store (av, i, sv);
                      buf += SvCUR (sv) + 1;
                    }

                  rv = sv_2mortal (newRV_noinc ((SV *)av));
                }

              PUSHs (rv);
            }
            break;

          case EIO_OPEN:
            {
              /* convert fd to fh */
              SV *fh = &PL_sv_undef;

              if (req->result >= 0)
                {
                  GV *gv = (GV *)sv_newmortal ();
                  int flags = req->int1 & (O_RDONLY | O_WRONLY | O_RDWR);
                  char sym [64];
                  int symlen;
                  
                  symlen = snprintf (sym, sizeof (sym), "fd#%d", req->result);
                  gv_init (gv, stash, sym, symlen, 0);

                  symlen = snprintf (
                     sym,
                     sizeof (sym),
                     "%s&=%d",
                     flags == O_RDONLY ? "<" : flags == O_WRONLY ? ">" : "+<",
                     req->result
                  );

                  if (do_open (gv, sym, symlen, 0, 0, 0, 0))
                    fh = (SV *)gv;
                }

              PUSHs (fh);
            }
            break;

          case EIO_GROUP:
            req->int1 = 2; /* mark group as finished */

            if (req->sv1)
              {
                int i;
                AV *av = (AV *)req->sv1;

                EXTEND (SP, AvFILL (av) + 1);
                for (i = 0; i <= AvFILL (av); ++i)
                  PUSHs (*av_fetch (av, i, 0));
              }
            break;

          case EIO_NOP:
          case EIO_BUSY:
            break;

          case EIO_READLINK:
            if (req->result > 0)
              PUSHs (sv_2mortal (newSVpvn (req->ptr2, req->result)));
            break;

          case EIO_STAT:
          case EIO_LSTAT:
          case EIO_FSTAT:
            PL_laststype   = req->type == EIO_LSTAT ? OP_LSTAT : OP_STAT;
            PL_laststatval = req->result;
            PL_statcache   = *(EIO_STRUCT_STAT *)(req->ptr2);
            PUSHs (sv_2mortal (newSViv (req->result)));
            break;

          case EIO_READ:
            SvCUR_set (req->sv2, req->stroffset + (req->result > 0 ? req->result : 0));
            *SvEND (req->sv2) = 0;
            PUSHs (sv_2mortal (newSViv (req->result)));
            break;

          case EIO_DUP2:
            if (req->result > 0)
              req->result = 0;
            /* FALLTHROUGH */

          default:
            PUSHs (sv_2mortal (newSViv (req->result)));
            break;
        }

      errno = req->errorno;

      PUTBACK;
      call_sv (req->callback, G_VOID | G_EVAL | G_DISCARD);
      SPAGAIN;

      FREETMPS;
      LEAVE;

      PUTBACK;
    }

  return !!SvTRUE (ERRSV);
}

static void req_destroy (aio_req req)
{
  if (req->self)
    {
      sv_unmagic (req->self, PERL_MAGIC_ext);
      SvREFCNT_dec (req->self);
    }

  SvREFCNT_dec (req->sv1);
  SvREFCNT_dec (req->sv2);
  SvREFCNT_dec (req->callback);

  Safefree (req);
}

static void req_cancel_subs (aio_req grp)
{
  aio_req sub;

  if (grp->type != EIO_GROUP)
    return;

  SvREFCNT_dec (grp->sv2);
  grp->sv2 = 0;

  eio_grp_cancel (grp);
}

#ifdef USE_SOCKETS_AS_HANDLES
# define TO_SOCKET(x) (win32_get_osfhandle (x))
#else
# define TO_SOCKET(x) (x)
#endif

static void
create_respipe (void)
{
  int old_readfd = respipe [0];

  if (respipe [1] >= 0)
    respipe_close (TO_SOCKET (respipe [1]));

#ifdef _WIN32
  if (PerlSock_socketpair (AF_UNIX, SOCK_STREAM, 0, respipe))
#else
  if (pipe (respipe))
#endif
    croak ("unable to initialize result pipe");

  if (old_readfd >= 0)
    {
      if (dup2 (TO_SOCKET (respipe [0]), TO_SOCKET (old_readfd)) < 0)
        croak ("unable to initialize result pipe(2)");

      respipe_close (respipe [0]);
      respipe [0] = old_readfd;
    }

#ifdef _WIN32
  int arg = 1;
  if (ioctlsocket (TO_SOCKET (respipe [0]), FIONBIO, &arg)
      || ioctlsocket (TO_SOCKET (respipe [1]), FIONBIO, &arg))
#else
  if (fcntl (respipe [0], F_SETFL, O_NONBLOCK)
      || fcntl (respipe [1], F_SETFL, O_NONBLOCK))
#endif
    croak ("unable to initialize result pipe(3)");

  respipe_osf [0] = TO_SOCKET (respipe [0]);
  respipe_osf [1] = TO_SOCKET (respipe [1]);
}

static void poll_wait (void)
{
  fd_set rfd;

  while (eio_nreqs ())
    {
      int size;

      X_LOCK   (reslock);
      size = res_queue.size;
      X_UNLOCK (reslock);

      if (size)
        return;

      etp_maybe_start_thread ();

      FD_ZERO (&rfd);
      FD_SET (respipe [0], &rfd);

      PerlSock_select (respipe [0] + 1, &rfd, 0, 0, 0);
    }
}

static int poll_cb (void)
{
  for (;;)
    {
      int res = eio_poll ();

      if (res > 0)
        croak (0);

      if (!max_outstanding || max_outstanding > eio_nreqs ())
        return res;

      poll_wait ();
    }
}

static void atfork_child (void)
{
  create_respipe ();
}

static SV *
get_cb (SV *cb_sv)
{
  HV *st;
  GV *gvp;
  CV *cv;

  if (!SvOK (cb_sv))
    return 0;

  cv = sv_2cv (cb_sv, &st, &gvp, 0);

  if (!cv)
    croak ("IO::AIO callback must be undef or a CODE reference");

  return (SV *)cv;
}

#define dREQ							\
  SV *cb_cv;							\
  aio_req req;							\
  int req_pri = next_pri;					\
  next_pri = EIO_PRI_DEFAULT;					\
								\
  cb_cv = get_cb (callback);					\
								\
  Newz (0, req, 1, eio_req);					\
  if (!req)							\
    croak ("out of memory during eio_req allocation");		\
								\
  req->callback = SvREFCNT_inc (cb_cv);				\
  req->pri = req_pri

#define REQ_SEND						\
  PUTBACK;							\
  req_submit (req);						\
  SPAGAIN;							\
								\
  if (GIMME_V != G_VOID)					\
    XPUSHs (req_sv (req, AIO_REQ_KLASS));
	
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 519 "AIO.c"

XS(XS_IO__AIO_max_poll_reqs); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_max_poll_reqs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::max_poll_reqs", "nreqs");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nreqs = (int)SvIV(ST(0));
#line 539 "AIO.xs"
        eio_set_max_poll_reqs (nreqs);
#line 536 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_max_poll_time); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_max_poll_time)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::max_poll_time", "nseconds");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	double	nseconds = (double)SvNV(ST(0));
#line 545 "AIO.xs"
        eio_set_max_poll_time (nseconds);
#line 557 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_min_parallel); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_min_parallel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::min_parallel", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));
#line 551 "AIO.xs"
        eio_set_min_parallel (nthreads);
#line 578 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_max_parallel); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_max_parallel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::max_parallel", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));
#line 557 "AIO.xs"
        eio_set_max_parallel (nthreads);
#line 599 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_max_idle); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_max_idle)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::max_idle", "nthreads");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nthreads = (int)SvIV(ST(0));
#line 563 "AIO.xs"
        eio_set_max_idle (nthreads);
#line 620 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_max_outstanding); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_max_outstanding)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::max_outstanding", "maxreqs");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	maxreqs = (int)SvIV(ST(0));
#line 569 "AIO.xs"
        max_outstanding = maxreqs;
#line 641 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_aio_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_open", "pathname, flags, mode, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	int	flags = (int)SvIV(ST(1));
	int	mode = (int)SvIV(ST(2));
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname");

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3);
	}
#line 575 "AIO.xs"
{
        dREQ;

        req->type = EIO_OPEN;
        req->sv1  = newSVsv (pathname);
        req->ptr1 = SvPVbyte_nolen (req->sv1);
        req->int1 = flags;
        req->int2 = mode;

        REQ_SEND;
}
#line 687 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_fsync); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_fsync)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "fh, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0);
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 594 "AIO.xs"
{
        dREQ;

        req->type = ix;
        req->sv1  = newSVsv (fh);
        req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh)));

        REQ_SEND (req);
}
#line 727 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_sync_file_range); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_sync_file_range)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_sync_file_range", "fh, offset, nbytes, flags, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0);
	SV *	offset = ST(1);
	SV *	nbytes = ST(2);
	IV	flags = (IV)SvIV(ST(3));
	SV *	callback;

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4);
	}
#line 608 "AIO.xs"
{
        dREQ;

        req->type = EIO_SYNC_FILE_RANGE;
        req->sv1  = newSVsv (fh);
        req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh)));
        req->offs = SvVAL64 (offset);
        req->size = SvVAL64 (nbytes);
        req->int2 = flags;

        REQ_SEND (req);
}
#line 772 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_close", "fh, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0);
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 625 "AIO.xs"
{
        static int close_pipe = -1; /* dummy fd to close fds via dup2 */
        dREQ;

        if (close_pipe < 0)
          {
            int pipefd [2];

            if (pipe (pipefd) < 0
                || close (pipefd [1]) < 0
                || fcntl (pipefd [0], F_SETFD, FD_CLOEXEC) < 0)
              abort (); /*D*/

            close_pipe = pipefd [0];
          }

        req->type = EIO_DUP2;
        req->int1 = close_pipe;
        req->sv2  = newSVsv (fh);
        req->int2 = PerlIO_fileno (IoIFP (sv_2io (fh)));

        REQ_SEND (req);
}
#line 825 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_read); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_read)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 5 || items > 6)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "fh, offset, length, data, dataoffset, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0);
	SV *	offset = ST(1);
	SV *	length = ST(2);
	SV8 *	data;
	IV	dataoffset = (IV)SvIV(ST(4));
	SV *	callback;

	(data) = ST(3);
        if (SvPOKp (data) && !sv_utf8_downgrade (data, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "data");

	if (items < 6)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(5);
	}
#line 656 "AIO.xs"
{
        STRLEN svlen;
        char *svptr = SvPVbyte (data, svlen);
        UV len = SvUV (length);

        SvUPGRADE (data, SVt_PV);
        SvPOK_on (data);

        if (dataoffset < 0)
          dataoffset += svlen;

        if (dataoffset < 0 || dataoffset > svlen)
          croak ("dataoffset outside of data scalar");

        if (ix == EIO_WRITE)
          {
            /* write: check length and adjust. */
            if (!SvOK (length) || len + dataoffset > svlen)
              len = svlen - dataoffset;
          }
        else
          {
            /* read: grow scalar as necessary */
            svptr = SvGROW (data, len + dataoffset + 1);
          }

        if (len < 0)
          croak ("length must not be negative");

        {
          dREQ;

          req->type = ix;
          req->sv1  = newSVsv (fh);
          req->int1 = PerlIO_fileno (ix == EIO_READ ? IoIFP (sv_2io (fh))
                                                    : IoOFP (sv_2io (fh)));
          req->offs = SvOK (offset) ? SvVAL64 (offset) : -1;
          req->size = len;
          req->sv2  = SvREFCNT_inc (data);
          req->ptr2 = (char *)svptr + dataoffset;
          req->stroffset = dataoffset;

          if (!SvREADONLY (data))
            {
              SvREADONLY_on (data);
              req->flags |= FLAG_SV2_RO_OFF;
            }

          REQ_SEND;
        }
}
#line 915 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_readlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_readlink)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_readlink", "path, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	path;
	SV *	callback;

	(path) = ST(0);
        if (SvPOKp (path) && !sv_utf8_downgrade (path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "path");

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 712 "AIO.xs"
{
	SV *data;
        dREQ;

        req->type = EIO_READLINK;
        req->sv1  = newSVsv (path);
        req->ptr1 = SvPVbyte_nolen (req->sv1);

        REQ_SEND;
}
#line 959 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_sendfile); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_sendfile)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 4 || items > 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_sendfile", "out_fh, in_fh, in_offset, length, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	out_fh = ST(0);
	SV *	in_fh = ST(1);
	SV *	in_offset = ST(2);
	UV	length = (UV)SvUV(ST(3));
	SV *	callback;

	if (items < 5)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(4);
	}
#line 727 "AIO.xs"
{
	dREQ;

        req->type = EIO_SENDFILE;
        req->sv1  = newSVsv (out_fh);
        req->int1 = PerlIO_fileno (IoIFP (sv_2io (out_fh)));
        req->sv2  = newSVsv (in_fh);
        req->int2 = PerlIO_fileno (IoIFP (sv_2io (in_fh)));
        req->offs = SvVAL64 (in_offset);
        req->size = length;

        REQ_SEND;
}
#line 1005 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_readahead); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_readahead)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_readahead", "fh, offset, length, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	fh = ST(0);
	SV *	offset = ST(1);
	IV	length = (IV)SvIV(ST(2));
	SV *	callback;

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3);
	}
#line 745 "AIO.xs"
{
	dREQ;

        req->type = EIO_READAHEAD;
        req->sv1  = newSVsv (fh);
        req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh)));
        req->offs = SvVAL64 (offset);
        req->size = length;

        REQ_SEND;
}
#line 1048 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_stat); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_stat)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "fh_or_path, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path");

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 763 "AIO.xs"
{
	dREQ;

        req->sv1 = newSVsv (fh_or_path);

        if (SvPOK (req->sv1))
          {
            req->type = ix;
            req->ptr1 = SvPVbyte_nolen (req->sv1);
          }
        else
          {
            req->type = EIO_FSTAT;
            req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
          }

        REQ_SEND;
}
#line 1101 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_utime); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_utime)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_utime", "fh_or_path, atime, mtime, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	atime = ST(1);
	SV *	mtime = ST(2);
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path");

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3);
	}
#line 785 "AIO.xs"
{
	dREQ;

        req->nv1 = SvOK (atime) ? SvNV (atime) : -1.;
        req->nv2 = SvOK (mtime) ? SvNV (mtime) : -1.;
        req->sv1 = newSVsv (fh_or_path);

        if (SvPOK (req->sv1))
          {
            req->type = EIO_UTIME;
            req->ptr1 = SvPVbyte_nolen (req->sv1);
          }
        else
          {
            req->type = EIO_FUTIME;
            req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
          }

        REQ_SEND;
}
#line 1157 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_truncate); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_truncate)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_truncate", "fh_or_path, offset, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	offset = ST(1);
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path");

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2);
	}
#line 809 "AIO.xs"
{
	dREQ;

        req->sv1  = newSVsv (fh_or_path);
        req->offs = SvOK (offset) ? SvVAL64 (offset) : -1;

        if (SvPOK (req->sv1))
          {
            req->type = EIO_TRUNCATE;
            req->ptr1 = SvPVbyte_nolen (req->sv1);
          }
        else
          {
            req->type = EIO_FTRUNCATE;
            req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
          }

        REQ_SEND;
}
#line 1211 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_chmod); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_chmod)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "fh_or_path, mode, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	int	mode = (int)SvIV(ST(1));
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path");

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2);
	}
#line 835 "AIO.xs"
{
	dREQ;

        req->int2 = mode;
        req->sv1  = newSVsv (fh_or_path);

        if (SvPOK (req->sv1))
          {
            req->type = ix;
            req->ptr1 = SvPVbyte_nolen (req->sv1);
          }
        else
          {
            req->type = EIO_FCHMOD;
            req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
          }

        REQ_SEND;
}
#line 1266 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_chown); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_chown)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_chown", "fh_or_path, uid, gid, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	fh_or_path;
	SV *	uid = ST(1);
	SV *	gid = ST(2);
	SV *	callback;

	(fh_or_path) = ST(0);
        if (SvPOKp (fh_or_path) && !sv_utf8_downgrade (fh_or_path, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "fh_or_path");

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3);
	}
#line 858 "AIO.xs"
{
	dREQ;

        req->int2 = SvOK (uid) ? SvIV (uid) : -1;
        req->int3 = SvOK (gid) ? SvIV (gid) : -1;
        req->sv1  = newSVsv (fh_or_path);

        if (SvPOK (req->sv1))
          {
            req->type = EIO_CHOWN;
            req->ptr1 = SvPVbyte_nolen (req->sv1);
          }
        else
          {
            req->type = EIO_FCHOWN;
            req->int1 = PerlIO_fileno (IoIFP (sv_2io (fh_or_path)));
          }

        REQ_SEND;
}
#line 1322 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_unlink); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_unlink)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "pathname, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname");

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 886 "AIO.xs"
{
	dREQ;

        req->type = ix;
	req->sv1  = newSVsv (pathname);
	req->ptr1 = SvPVbyte_nolen (req->sv1);

	REQ_SEND;
}
#line 1366 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_link); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_link)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 2 || items > 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "oldpath, newpath, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	oldpath;
	SV8 *	newpath;
	SV *	callback;

	(oldpath) = ST(0);
        if (SvPOKp (oldpath) && !sv_utf8_downgrade (oldpath, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "oldpath");

	(newpath) = ST(1);
        if (SvPOKp (newpath) && !sv_utf8_downgrade (newpath, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "newpath");

	if (items < 3)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(2);
	}
#line 903 "AIO.xs"
{
	dREQ;

        req->type = ix;
	req->sv1  = newSVsv (oldpath);
	req->ptr1 = SvPVbyte_nolen (req->sv1);
	req->sv2  = newSVsv (newpath);
	req->ptr2 = SvPVbyte_nolen (req->sv2);

	REQ_SEND;
}
#line 1417 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_mknod); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_mknod)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 3 || items > 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_mknod", "pathname, mode, dev, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV8 *	pathname;
	int	mode = (int)SvIV(ST(1));
	UV	dev = (UV)SvUV(ST(2));
	SV *	callback;

	(pathname) = ST(0);
        if (SvPOKp (pathname) && !sv_utf8_downgrade (pathname, 1))
          croak ("\"%s\" argument must be byte/octet-encoded", "pathname");

	if (items < 4)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(3);
	}
#line 918 "AIO.xs"
{
	dREQ;

        req->type = EIO_MKNOD;
	req->sv1  = newSVsv (pathname);
	req->ptr1 = SvPVbyte_nolen (req->sv1);
        req->int2 = (mode_t)mode;
        req->offs = dev;

	REQ_SEND;
}
#line 1464 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_busy); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_busy)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_busy", "delay, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	double	delay = (double)SvNV(ST(0));
	SV *	callback;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 933 "AIO.xs"
{
	dREQ;

        req->type = EIO_BUSY;
        req->nv1  = delay < 0. ? 0. : delay;

	REQ_SEND;
}
#line 1502 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_group); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_group)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aio_group", "callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	callback;

	if (items < 1)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(0);
	}
#line 946 "AIO.xs"
{
	dREQ;

        req->type = EIO_GROUP;

        req_submit (req);
        XPUSHs (req_sv (req, AIO_GRP_KLASS));
}
#line 1539 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aio_nop); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aio_nop)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", GvNAME(CvGV(cv)), "callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	callback;

	if (items < 1)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(0);
	}
#line 961 "AIO.xs"
{
	dREQ;

        req->type = ix;

	REQ_SEND;
}
#line 1576 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO_aioreq_pri); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aioreq_pri)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aioreq_pri", "pri= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
	int	pri;

	if (items < 1)
	    pri = 0;
	else {
	    pri = (int)SvIV(ST(0));
	}
#line 973 "AIO.xs"
	RETVAL = next_pri;
	if (items > 0)
	  {
	    if (pri < EIO_PRI_MIN) pri = EIO_PRI_MIN;
	    if (pri > EIO_PRI_MAX) pri = EIO_PRI_MAX;
	    next_pri = pri;
	  }
#line 1612 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_aioreq_nice); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_aioreq_nice)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::aioreq_nice", "nice= 0");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	nice;

	if (items < 1)
	    nice = 0;
	else {
	    nice = (int)SvIV(ST(0));
	}
#line 986 "AIO.xs"
	nice = next_pri - nice;
	if (nice < EIO_PRI_MIN) nice = EIO_PRI_MIN;
	if (nice > EIO_PRI_MAX) nice = EIO_PRI_MAX;
	next_pri = nice;
#line 1643 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::flush", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 995 "AIO.xs"
        while (eio_nreqs ())
          {
            poll_wait ();
            poll_cb ();
          }
#line 1667 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_poll); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_poll)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::poll", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1005 "AIO.xs"
        poll_wait ();
        RETVAL = poll_cb ();
#line 1690 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_poll_fileno); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_poll_fileno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::poll_fileno", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1014 "AIO.xs"
        RETVAL = respipe [0];
#line 1713 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_poll_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_poll_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1022 "AIO.xs"
        RETVAL = poll_cb ();
#line 1734 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_poll_wait); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_poll_wait)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::poll_wait", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 1030 "AIO.xs"
        poll_wait ();
#line 1755 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO_nreqs); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_nreqs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::nreqs", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1036 "AIO.xs"
        RETVAL = eio_nreqs ();
#line 1777 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_nready); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_nready)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::nready", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1044 "AIO.xs"
        RETVAL = eio_nready ();
#line 1800 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_npending); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_npending)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::npending", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1052 "AIO.xs"
        RETVAL = eio_npending ();
#line 1823 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO_nthreads); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO_nthreads)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::nthreads", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	RETVAL;
	dXSTARG;
#line 1060 "AIO.xs"
        RETVAL = eio_nthreads ();
#line 1846 "AIO.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_IO__AIO__on_next_submit); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__on_next_submit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::_on_next_submit", "cb");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	SV *	cb = ST(0);
#line 1066 "AIO.xs"
        SvREFCNT_dec (on_next_submit);
        on_next_submit = SvOK (cb) ? newSVsv (cb) : 0;
#line 1869 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__REQ_cancel); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__REQ_cancel)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::REQ::cancel", "req");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req_ornot	req;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY;
#line 1076 "AIO.xs"
        eio_cancel (req);
#line 1893 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__REQ_cb); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__REQ_cb)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::REQ::cb", "req, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	aio_req_ornot	req;
	SV *	callback;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY;

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 1081 "AIO.xs"
{
        if (GIMME_V != G_VOID)
          XPUSHs (req->callback ? sv_2mortal (newRV_inc (req->callback)) : &PL_sv_undef);

        if (items > 1)
          {
            SV *cb_cv = get_cb (callback);

            SvREFCNT_dec (req->callback);
            req->callback = SvREFCNT_inc (cb_cv);
          }
}
#line 1937 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO__GRP_add); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_add)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::add", "grp, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	aio_req	grp;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy " AIO_REQ_KLASS " object expected");
#line 1099 "AIO.xs"
{
	int i;

        if (grp->int1 == 2)
          croak ("cannot add requests to IO::AIO::GRP after the group finished");

	for (i = 1; i < items; ++i )
          {
            aio_req req;

            if (GIMME_V != G_VOID)
              XPUSHs (sv_2mortal (newSVsv (ST (i))));

            req = SvAIO_REQ (ST (i));

            if (req)
              eio_grp_add (grp, req);
          }
}
#line 1982 "AIO.c"
	PUTBACK;
	return;
    }
}


XS(XS_IO__AIO__GRP_cancel_subs); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_cancel_subs)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::cancel_subs", "req");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req_ornot	req;

	if (!(req = SvAIO_REQ (ST(0))))
	  XSRETURN_EMPTY;
#line 1122 "AIO.xs"
        req_cancel_subs (req);
#line 2007 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__GRP_result); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_result)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::result", "grp, ...");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req	grp;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy " AIO_REQ_KLASS " object expected");
#line 1127 "AIO.xs"
{
        int i;
        AV *av;

        grp->errorno = errno;

        av = newAV ();

        for (i = 1; i < items; ++i )
          av_push (av, newSVsv (ST (i)));

        SvREFCNT_dec (grp->sv1);
        grp->sv1 = (SV *)av;
}
#line 2044 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__GRP_errno); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_errno)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::errno", "grp, errorno= errno");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req	grp;
	int	errorno;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy " AIO_REQ_KLASS " object expected");

	if (items < 2)
	    errorno = errno;
	else {
	    errorno = (int)SvIV(ST(1));
	}
#line 1145 "AIO.xs"
        grp->errorno = errorno;
#line 2075 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__GRP_limit); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_limit)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::limit", "grp, limit");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req	grp;
	int	limit = (int)SvIV(ST(1));

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy " AIO_REQ_KLASS " object expected");
#line 1150 "AIO.xs"
        eio_grp_limit (grp, limit);
#line 2100 "AIO.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_IO__AIO__GRP_feed); /* prototype to pass -Wmissing-prototypes */
XS(XS_IO__AIO__GRP_feed)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "IO::AIO::GRP::feed", "grp, callback=&PL_sv_undef");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	aio_req	grp;
	SV *	callback;

	if (!(grp = SvAIO_REQ (ST(0))))
          croak ("busy " AIO_REQ_KLASS " object expected");

	if (items < 2)
	    callback = &PL_sv_undef;
	else {
	    callback = ST(1);
	}
#line 1155 "AIO.xs"
{
        SvREFCNT_dec (grp->sv2);
        grp->sv2  = newSVsv (callback);
        grp->feed = aio_grp_feed;

        if (grp->int2 <= 0)
          grp->int2 = 2;

        eio_grp_limit (grp, grp->int2);
}
#line 2140 "AIO.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_IO__AIO); /* prototype to pass -Wmissing-prototypes */
XS(boot_IO__AIO)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        newXSproto("IO::AIO::max_poll_reqs", XS_IO__AIO_max_poll_reqs, file, "$");
        newXSproto("IO::AIO::max_poll_time", XS_IO__AIO_max_poll_time, file, "$");
        newXSproto("IO::AIO::min_parallel", XS_IO__AIO_min_parallel, file, "$");
        newXSproto("IO::AIO::max_parallel", XS_IO__AIO_max_parallel, file, "$");
        newXSproto("IO::AIO::max_idle", XS_IO__AIO_max_idle, file, "$");
        newXSproto("IO::AIO::max_outstanding", XS_IO__AIO_max_outstanding, file, "$");
        newXSproto("IO::AIO::aio_open", XS_IO__AIO_aio_open, file, "$$$;$");
        cv = newXS("IO::AIO::aio_fsync", XS_IO__AIO_aio_fsync, file);
        XSANY.any_i32 = EIO_FSYNC ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("IO::AIO::aio_fdatasync", XS_IO__AIO_aio_fsync, file);
        XSANY.any_i32 = EIO_FDATASYNC ;
        sv_setpv((SV*)cv, "$;$") ;
        newXSproto("IO::AIO::aio_sync_file_range", XS_IO__AIO_aio_sync_file_range, file, "$$$$;$");
        newXSproto("IO::AIO::aio_close", XS_IO__AIO_aio_close, file, "$;$");
        cv = newXS("IO::AIO::aio_write", XS_IO__AIO_aio_read, file);
        XSANY.any_i32 = EIO_WRITE ;
        sv_setpv((SV*)cv, "$$$$$;$") ;
        cv = newXS("IO::AIO::aio_read", XS_IO__AIO_aio_read, file);
        XSANY.any_i32 = EIO_READ ;
        sv_setpv((SV*)cv, "$$$$$;$") ;
        newXSproto("IO::AIO::aio_readlink", XS_IO__AIO_aio_readlink, file, "$$;$");
        newXSproto("IO::AIO::aio_sendfile", XS_IO__AIO_aio_sendfile, file, "$$$$;$");
        newXSproto("IO::AIO::aio_readahead", XS_IO__AIO_aio_readahead, file, "$$$;$");
        cv = newXS("IO::AIO::aio_lstat", XS_IO__AIO_aio_stat, file);
        XSANY.any_i32 = EIO_LSTAT ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("IO::AIO::aio_stat", XS_IO__AIO_aio_stat, file);
        XSANY.any_i32 = EIO_STAT ;
        sv_setpv((SV*)cv, "$;$") ;
        newXSproto("IO::AIO::aio_utime", XS_IO__AIO_aio_utime, file, "$$$;$");
        newXSproto("IO::AIO::aio_truncate", XS_IO__AIO_aio_truncate, file, "$$;$");
        cv = newXS("IO::AIO::aio_chmod", XS_IO__AIO_aio_chmod, file);
        XSANY.any_i32 = EIO_CHMOD ;
        sv_setpv((SV*)cv, "$$;$") ;
        cv = newXS("IO::AIO::aio_mkdir", XS_IO__AIO_aio_chmod, file);
        XSANY.any_i32 = EIO_MKDIR ;
        sv_setpv((SV*)cv, "$$;$") ;
        newXSproto("IO::AIO::aio_chown", XS_IO__AIO_aio_chown, file, "$$$;$");
        cv = newXS("IO::AIO::aio_readdir", XS_IO__AIO_aio_unlink, file);
        XSANY.any_i32 = EIO_READDIR ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("IO::AIO::aio_unlink", XS_IO__AIO_aio_unlink, file);
        XSANY.any_i32 = EIO_UNLINK ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("IO::AIO::aio_rmdir", XS_IO__AIO_aio_unlink, file);
        XSANY.any_i32 = EIO_RMDIR ;
        sv_setpv((SV*)cv, "$;$") ;
        cv = newXS("IO::AIO::aio_rename", XS_IO__AIO_aio_link, file);
        XSANY.any_i32 = EIO_RENAME ;
        sv_setpv((SV*)cv, "$$;$") ;
        cv = newXS("IO::AIO::aio_symlink", XS_IO__AIO_aio_link, file);
        XSANY.any_i32 = EIO_SYMLINK ;
        sv_setpv((SV*)cv, "$$;$") ;
        cv = newXS("IO::AIO::aio_link", XS_IO__AIO_aio_link, file);
        XSANY.any_i32 = EIO_LINK ;
        sv_setpv((SV*)cv, "$$;$") ;
        newXSproto("IO::AIO::aio_mknod", XS_IO__AIO_aio_mknod, file, "$$$;$");
        newXSproto("IO::AIO::aio_busy", XS_IO__AIO_aio_busy, file, "$;$");
        newXSproto("IO::AIO::aio_group", XS_IO__AIO_aio_group, file, ";$");
        cv = newXS("IO::AIO::aio_sync", XS_IO__AIO_aio_nop, file);
        XSANY.any_i32 = EIO_SYNC ;
        sv_setpv((SV*)cv, ";$") ;
        cv = newXS("IO::AIO::aio_nop", XS_IO__AIO_aio_nop, file);
        XSANY.any_i32 = EIO_NOP ;
        sv_setpv((SV*)cv, ";$") ;
        newXSproto("IO::AIO::aioreq_pri", XS_IO__AIO_aioreq_pri, file, ";$");
        newXSproto("IO::AIO::aioreq_nice", XS_IO__AIO_aioreq_nice, file, ";$");
        newXSproto("IO::AIO::flush", XS_IO__AIO_flush, file, "");
        newXSproto("IO::AIO::poll", XS_IO__AIO_poll, file, "");
        newXSproto("IO::AIO::poll_fileno", XS_IO__AIO_poll_fileno, file, "");
        newXSproto("IO::AIO::poll_cb", XS_IO__AIO_poll_cb, file, "");
        newXSproto("IO::AIO::poll_wait", XS_IO__AIO_poll_wait, file, "");
        newXSproto("IO::AIO::nreqs", XS_IO__AIO_nreqs, file, "");
        newXSproto("IO::AIO::nready", XS_IO__AIO_nready, file, "");
        newXSproto("IO::AIO::npending", XS_IO__AIO_npending, file, "");
        newXSproto("IO::AIO::nthreads", XS_IO__AIO_nthreads, file, "");
        newXSproto("IO::AIO::_on_next_submit", XS_IO__AIO__on_next_submit, file, "$");
        newXS("IO::AIO::REQ::cancel", XS_IO__AIO__REQ_cancel, file);
        newXS("IO::AIO::REQ::cb", XS_IO__AIO__REQ_cb, file);
        newXS("IO::AIO::GRP::add", XS_IO__AIO__GRP_add, file);
        newXS("IO::AIO::GRP::cancel_subs", XS_IO__AIO__GRP_cancel_subs, file);
        newXS("IO::AIO::GRP::result", XS_IO__AIO__GRP_result, file);
        newXS("IO::AIO::GRP::errno", XS_IO__AIO__GRP_errno, file);
        newXS("IO::AIO::GRP::limit", XS_IO__AIO__GRP_limit, file);
        newXS("IO::AIO::GRP::feed", XS_IO__AIO__GRP_feed, file);
    }

    /* Initialisation Section */

#line 510 "AIO.xs"
{
	stash = gv_stashpv ("IO::AIO", 1);

        newCONSTSUB (stash, "EXDEV",    newSViv (EXDEV));
        newCONSTSUB (stash, "O_RDONLY", newSViv (O_RDONLY));
        newCONSTSUB (stash, "O_WRONLY", newSViv (O_WRONLY));
        newCONSTSUB (stash, "O_CREAT",  newSViv (O_CREAT));
        newCONSTSUB (stash, "O_TRUNC",  newSViv (O_TRUNC));
#ifndef _WIN32
        newCONSTSUB (stash, "S_IFIFO",  newSViv (S_IFIFO));
#endif
        newCONSTSUB (stash, "S_IFIFO",  newSViv (S_IFIFO));
        newCONSTSUB (stash, "SYNC_FILE_RANGE_WAIT_BEFORE", newSViv (EIO_SYNC_FILE_RANGE_WAIT_BEFORE));
        newCONSTSUB (stash, "SYNC_FILE_RANGE_WRITE"      , newSViv (EIO_SYNC_FILE_RANGE_WRITE));
        newCONSTSUB (stash, "SYNC_FILE_RANGE_WAIT_AFTER" , newSViv (EIO_SYNC_FILE_RANGE_WAIT_AFTER));

        create_respipe ();

        if (eio_init (want_poll, done_poll) < 0)
          croak ("IO::AIO: unable to initialise eio library");

        /* atfork child called in fifo order, so before eio's handler */
        X_THREAD_ATFORK (0, 0, atfork_child);
}

#line 2281 "AIO.c"

    /* End of Initialisation Section */

    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

